import webpack from 'webpack';
import { MicroAppConfig } from './micro-fe-app-config';
interface EmitMfExposeWebpackPluginOptions {
    appConfig: MicroAppConfig;
    outputBasePath?: string;
}
/**
 * 防抖函数
 *
 * @author yuzhanglong
 * @date 2021-12-01 00:51:19
 */
export declare const debounce: <T extends (...args: any[]) => any>(fn: T, timeout?: number) => (...args: Parameters<T>) => void;
/**
 * 向 build 打包产物注入类型定义的 webpack-plugin
 *
 * @author yuzhanglong
 * @date 2021-10-03 19:31:02
 */
export declare class EmitMfExposeWebpackPlugin {
    private readonly config;
    constructor(config: EmitMfExposeWebpackPluginOptions);
    apply(compiler: webpack.Compiler): void;
}
export {};
