"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MicroApp = void 0;
const react_1 = __importStar(require("react"));
const qiankun_1 = require("qiankun");
exports.MicroApp = (0, react_1.forwardRef)((props, microAppRef) => {
    const { current } = (0, react_1.useRef)({
        containerRef: null,
        microApp: null,
    });
    const loadApp = () => {
        if (current.containerRef) {
            current.microApp = (0, qiankun_1.loadMicroApp)({
                ...props.microAppConfig,
                container: current.containerRef,
            }, {
                sandbox: {
                    experimentalStyleIsolation: true,
                },
            });
        }
    };
    (0, react_1.useEffect)(() => {
        loadApp();
        return () => {
            current.microApp?.unmount();
        };
    }, []);
    (0, react_1.useEffect)(() => {
        if (current.microApp && current.microApp.update) {
            current.microApp.update({});
        }
    }, []);
    (0, react_1.useImperativeHandle)(microAppRef, () => {
        return {
            appStore: current,
        };
    });
    return (react_1.default.createElement("div", { className: `micro-app-${props.microAppConfig.name}`, ref: (ref) => {
            current.containerRef = ref;
        } }));
});
//# sourceMappingURL=micro-app.js.map