"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateMfExposeDeclaration = void 0;
/**
 * 生成 module federation expose 声明，一般用于消费者调用
 *
 * @author yuzhanglong
 * @date 2021-10-02 14:53:24
 */
const axios_1 = __importDefault(require("axios"));
const url = __importStar(require("url"));
const fs = __importStar(require("fs-extra"));
const path = __importStar(require("path"));
const paths_1 = require("../common/paths");
const generateMfExposeDeclaration = async (appConfig) => {
    const declareTypeRoot = path.resolve(paths_1.sourcePath, 'types', 'mf-remotes');
    await fs.ensureDir(declareTypeRoot);
    for (const { name, url: remoteUrl } of appConfig.remotes) {
        const targetFileName = `${name}-exposes.d.ts`;
        // example: https://base-40kkvlqeq-yzl.vercel.app/mf-expose-types/exposes.d.ts
        const remote = url.resolve(remoteUrl, 'mf-expose-types/exposes.d.ts');
        console.log(`fetching remotes types declarations from ${remote}...`);
        const declarations = await axios_1.default.get(remote);
        await fs.writeFile(path.resolve(declareTypeRoot, targetFileName), declarations.data);
    }
    console.log('Done!');
};
exports.generateMfExposeDeclaration = generateMfExposeDeclaration;
//# sourceMappingURL=generate-mf-expose-declaration.js.map