"use strict";
/**
 * File: get-mf-exposes.ts
 * Description: 根据配置的目录（src/externals 下）, 生成 webpack module federation 配置
 * Created: 2021-08-29 13:39:40
 * Author: yuzhanglong
 * Email: yuzl1123@163.com
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getModuleFederationExposes = void 0;
const enhanced_resolve_1 = require("enhanced-resolve");
const fs = __importStar(require("fs"));
const myResolver = enhanced_resolve_1.ResolverFactory.createResolver({
    fileSystem: new enhanced_resolve_1.CachedInputFileSystem(fs, 4000),
    conditionNames: ['node'],
    extensions: ['.js', '.json', '.node'],
    useSyncFileSystemCalls: true,
    mainFields: ['esm', 'module', 'main'],
});
function getModuleFederationExposes(modules) {
    const exposes = {};
    for (const module of modules) {
        if (typeof module === 'string') {
            const key = `./${module}`;
            const resolveResult = myResolver.resolveSync({}, process.cwd(), module);
            if (typeof resolveResult !== 'string') {
                throw new Error(`resolve error: ${module}`);
            }
            exposes[key] = resolveResult;
        }
        else if (typeof module === 'object') {
            exposes[`./${module.name}`] = module.path;
        }
    }
    return exposes;
}
exports.getModuleFederationExposes = getModuleFederationExposes;
//# sourceMappingURL=get-module-federation-exposes.js.map